<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en"> <!--<![endif]-->

<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="IE=Edge">

  <link rel="stylesheet" href="css/normalize.css" />
  <link rel="stylesheet" href="css/foundation.css" />
  <link rel="stylesheet" href="css/style.css">
  <script src="js/vendor/custom.modernizr.js"></script>
  <script src="js/jquery-latest.min.js"></script>

  <title>Random Name Generator</title>
</head>
<body onload="reset();">

  <div class="full-head">
    <div class="button group-gen-container">
      <a class="group-gen" href="group-gen.html"><img src="./img/group-gen-logo.png" alt="group-gen-logo"
                                                      width="50"
                                                      height="100">
        GroupGen</a>
    </div>
	<div class="row">
      <div class="large-12 columns columns-custom">
        <ul class="button-group even-4">
          <li><a href="index.html" class="alert button" id="reset">Reset</a></li>
          <li><button class="button" id="list" onclick="namelist();">Name List</button></li>
          <li><button class="button" id="save" onclick="save();">Save &amp; Update</button></li>
          <li><button class="success button" id="go" onclick="go();">GO!</button></li>
        </ul>
      </div>

    </div>
  </div>

  <div class="row">
    <div class="large-12 columns">
      <h3 class="headline" id="headline">The next one to answer will be: </h3>

      <div id="varnote"><img src="./img/golden-hammer.png" alt="logo">
        <div class="copyright">&copy;Coded by <strong>Sviatoslav Malysheskyi</strong>, 2021</div>
      </div>

      <div id="popdown">
        <div id="names" class="inbox">
          <textarea name="namesbox" id="namesbox"></textarea>
        </div>
      </div>

      <div id="values"></div>

    </div>
  </div>

  <script>
    document.write('<script src=' +
        ('__proto__' in {} ? 'js/vendor/zepto' : 'js/vendor/jquery') +
        '.js><\/script>')
  </script>

  <script src="js/foundation.min.js"></script>

  <script>$(document).foundation();</script>

  <script>
    let text;
    let names = [
      'Student 1',
      'Student 2',
      'Student 3',
      'Student 4',
      'Student 5',
      'Student 6',
    ];

    function reset(){
      // re-enable go button
      // setTimeout("$('#go').removeAttr('disabled')",11005);
      let namesbreak = "";

      if(gup('names') !== "") {
        let names = gup('names');
        namesbreak = names.replace(/101/g,'\n');
        namesbreak = namesbreak.replace(/%20/g,' ');
      } else   {
        let names = [
          'Student 1',
          'Student 2',
          'Student 3',
          'Student 4',
          'Student 5',
          'Student 6',
        ];

        for(let i in names){
          let name = names[i];

          if (name === "" || typeof(name) === undefined){}else{
            namesbreak = namesbreak + name + "\n";
          }
        }
      }

      $("#namesbox").val(namesbreak);
    }

    function gup(para) {
      para = para.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
      let regexS = "[\\?&]"+para+"=([^&#]*)";
      let regex = new RegExp( regexS );
      let results = regex.exec( window.location.href );

      if( results === null )
        return "";
      else
        return results[1];
    }


    function randOrd() {
      return (Math.round(Math.random())-0.5);
    }

    function save() {
      $("#varnote").hide();
      $("#popdown").show();
      $("#values").hide();
      $("div").remove("#result1");

      savenames = $("#namesbox").val();
      savenames = savenames.replace(/\n\r?/g, '101');
      $('#headline').fadeOut();
      $('#headline').text('The name list is saved and updated.').fadeIn();
      $("#names").show();
      $('#namesbox').attr('disabled','disabled');
    }

    function namelist() {
      $("#varnote").hide();
      $('#namesbox').removeAttr('disabled','disabled');
      $('#headline').text('Configure name list');
      $("#popdown").show();
      $("#values").hide();
      $("#names").show();
      $('body').css({"overflow-y": "visible"});
    }

    // does the actual animation
    function go() {
      $("#varnote").hide();
      $('body').css({"overflow-y": "hidden"});
      $('#go').attr('disabled','disabled');
      $('#list').attr('disabled','disabled');
      $('#save').attr('disabled','disabled');
      $('#headline').slideUp();
      $('#namesbox').slideDown();

      let count = 1;
      count = 1;
      $("div").remove("#result1");
      names = $("#namesbox").val();

      if(document.all) { // IE
        names=names.split("\n");
      } else { //Mozilla
        names=names.split("\n");
      }

      $("#values").show();
      $(".name").show();
      $("#popdown").hide();
      $("div").remove(".name");
      $("div").remove(".extra");
      $("#playback").html("");

      newtop = names.length * 200 * -1;
      //$('#values').css({top: -300});

      $('#values').css({top: + newtop});
      names.sort( randOrd );

      let fruits = new Array ( "apple", "pear", "orange", "banana" );
      //console.log(fruits);
      //console.log(names);
      //alert(newtop);

      for(let i in names) {
        if (names[i] === "" || typeof(names[i]) === undefined){
          count = count-1;
        } else {
          name = names[i];
          //console.log(name);

          $('#values').append('<div id=result'+count+' class=name>'+name+'</div>');
        }
        count = count+1;
      }

      for(let i in names) {
        if (names[i] === "" || typeof(names[i]) === undefined){}else{
          name = names[i];
          $('#values').append('<div class=name>'+name+'</div>');
        }
        count = count+1;
      }

      for(let i in names) {
        if (names[i] === "" || typeof(names[i]) === undefined){}else{
          name = names[i];
          $('#values').append('<div class=name>'+name+'</div>');
        }
        count = count+1;
      }

      text = $('#result1').text()
      $('#values').animate({top: '+176'},5000);

      // make it stand out
      setTimeout("standout(text)",5000);

      //setTimeout("$('#playback').hide('slow')",11005);
    }

    function standout(text) {
      $('#result1').removeClass('name');
      $('.name').animate({opacity: .25});
      $('#result1').animate({height: '+=60px'});
      $('#result1').append('<div class="extra"><a class="small alert button" href="#" onClick="removevictim();">Remove name from list</a></div>');
      $('#go').removeAttr('disabled','disabled');
      $('#list').removeAttr('disabled','disabled');
      $('#save').removeAttr('disabled','disabled');
      $('#headline').text('Found the Winner!');
      $('#headline').slideDown();
    }

    function removevictim() {
	// Removing victim from array and UI
	// names = names.filter(function(){ return true});
	// Rewriting namesbox contents
	let nameupdated = "";

	for(let i in names) {
	  name = names[i];
	  if (name === "" || name === text || typeof(name) === undefined){}else{
        nameupdated = nameupdated + "\n" + name;
      }
	}

	$('#namesbox').val("");
	$('#namesbox').val(nameupdated);
    $('#result1').html("Removed");
    $('#result1').fadeOut(1000, function() {$("div").remove("#result1");});
    $("div").remove(".name");
    $("div").remove(".extra");
    $('#headline').text('OK, this student is removed from the list! Click "GO!" button for next roll.');
    }
  </script>

</body>
</html>
